/* Some quick-and-dirty routines to allow us to allocate and free pages
   "at random".  There is very little sanity checking here.  User Beware! */

#include "Malloc.h"
#include "Assert.h"
#include "mpmy.h"
#include "page.h"

int PgHwm;
int PgInUse;

static int PgBrk;		/* the current 'break', we have allocated
				   pages up to here.
				 */
static int Nfree;		/* How many free pages are there? */
static int *FreeTbl;		/* These pages are free. */
static int FreeTblSz;		/* How big is the table of free pages? */

#define GROWBY 1024

PgId PgAlloc(void){
  PgId ret;

  if( Nfree == 0 ){
    int curbrk = PgBrk;
    PgId pg;

    PgBrk += GROWBY;
    /* Load 'em up backwards, so that we allocate them in increasing order */
    pg.proc = MPMY_Procnum();
    for(pg.pgnum=PgBrk-1; pg.pgnum>=curbrk; pg.pgnum--){
      PgFree(pg);
    }
    PgInUse += GROWBY;		/* it was decremented by PgFree */
  }
  PgInUse++;
  if( PgInUse > PgHwm )
    PgHwm = PgInUse;

  ret.pgnum = FreeTbl[--Nfree];
  ret.proc = MPMY_Procnum();
  return ret;
}

void PgFree(PgId pgid){
  assert(pgid.proc == MPMY_Procnum());
  if( Nfree == FreeTblSz ){
    FreeTblSz += GROWBY;
    FreeTbl = Realloc(FreeTbl, FreeTblSz*sizeof(*FreeTbl)); /* NEVER FREED!! */
  }
  PgInUse--;
  FreeTbl[Nfree++] = pgid.pgnum;
}
